<?php
function fetchAPI($url) {
	$content = '';
	if (ini_get('allow_url_fopen') == true) {
		$content = file_get_contents($url);
	} else {
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url . $key);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$content = curl_exec($ch);
		curl_close($ch);
	}
	return $content;
}

// Vous avez besoin d'un fichier de cache (Permission en écriture!)
$cacheFile = '/gplusrss-cache';

// Temps de mise en cache (En secondes)
$cacheTime = 10;

// Récupération de la query string
$tag = urlencode($_GET["tag"]);

// Votre clé API Google+ (API key)
// Pour l'accès à l'API publique > Clé pour les applications de serveur > à créer sur https://console.developers.google.com/project
$key = 'Votre-Clé-Api-G+'; // Connectez vous à la console développeur pour créer votre clé

// Configurations des informations du Flux
$urlSite = 'http://www.votre-site.fr/'; //URL de votre site
$urlRss = 'http://www.votre-site.fr/votre-dossier/rss-google-plus/rss-gplus-query.php'; //Chemin vers le script

$titleRss = urldecode($tag) . ' sur Google+'; //Titre du flux
$descriptionRss = 'Voici le flus rss de mes publications et partage sur Google Plus'; // Description du Flux

// Modifiez les paramêtres selon vos besoin. Documentation de l'API : https://developers.google.com/+/api/latest/activities.
$url = 'https://www.googleapis.com/plus/v1/activities?query='. $tag .'&language=fr&maxResults=20&orderBy=recent&key=';

// Gestion du cache
$lmod = @filemtime($cacheFile);
if (!isset($_GET['purgeCache']) && $lmod && filesize($cacheFile) && (time() - $lmod < $cacheTime)) {
	$content = file_get_contents($cacheFile);
} else {
	$content = fetchAPI($url . $key);
	if ($content)
		file_put_contents($cacheFile, $content);
}
if (!$content)
	die('Failed to load G+ data');
$gplus = json_decode($content);
if (!$gplus)
	die('Failed to decode G+ data');

// Construction du flux RSS
echo "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n";
echo "<rss xmlns:atom=\"http://www.w3.org/2005/Atom\" xmlns:geo=\"http://www.w3.org/2003/01/geo/wgs84_pos#\" version=\"2.0\">\n";
echo "<channel>\n";
echo "	<generator>RSS Google+ Xtendo </generator>\n";
echo "	<title>$titleRss</title>\n";
echo "	<link>$urlSite</link>\n";
echo "	<atom:link href=\"$urlRss\" rel=\"self\" type=\"application/rss+xml\"/>\n";
echo "	<description>$descriptionRss</description>\n";
echo "	<language>fr</language>\n";
//echo "	<pubDate>" . $gplus -> updated . "</pubDate>\n";
//echo "	<lastBuildDate>" . $gplus -> updated . "</lastBuildDate>\n";
foreach ($gplus->items as $item) {
	$object = $item -> object;
	echo "	<item>\n";
	if ($item -> title == '') {
		$title = "Post partagé";
	} else {
		$title = "{$item -> title}";
	}
	echo "		<title>" . $title . "</title>\n";
	echo "		<link>" . htmlspecialchars($item -> url) . "</link>\n";
	echo "		<guid>" . htmlspecialchars($item -> url) . "</guid>\n";
//	echo "		<comments>" . htmlspecialchars($object -> replies -> selfLink) . "</comments>\n";
//Conversion de la date de RFC3339 vers RFC822
	$my_date = $item -> updated;
	echo "		<pubDate>" . date('r', strtotime($my_date)) . "</pubDate>\n";
	if ($item -> verb == 'share') {
		$authororg = "{$object->actor->displayName}";
	} else {
		$authororg = "{$item -> actor->displayName}";
	}
	echo "		<author>" . $authororg . "</author>\n";
	echo "		<enclosure url=\"" . $item -> actor->image->url . "\" type=\"image/jpeg\" length=\"40240\"/>\n";
	if ($item -> verb == 'share') {
		$source = "<a href={$object->actor->url}><img src={$object->actor->image->url} />{$object->actor->displayName}</a>";
		$desc = "{$item->annotation}<p>&nbsp;<br/>";
		$desc .= "<em>$source:</em></p><blockquote>{$object->content}</blockquote>";
	} else {
		$desc = $item -> object -> content;
	}
	if (isset($item -> object -> attachments))
		foreach ($item->object->attachments as $attach) {
			if ($attach -> objectType == 'article') {
				$desc .= '<blockquote>';
				$desc .= '<b><a href="' . $attach -> url . '">' . $attach -> displayName . '</a></b><br /><br />';
				$desc .= $attach -> content;
				$desc .= '</blockquote>';
			} elseif ($attach -> objectType == 'photo') {
				echo "		<enclosure url=\"" . $attach -> image -> url . "\" type=\"" . $attach -> image -> type . "\" />\n";
			}
		}
	echo "		<description><![CDATA[<img src=\"" . $attach -> image -> url . "\" />" . $desc . "]]></description>\n";
	echo "		<enclosure url=\"" . $attach -> image -> url . "\" type=\"" . $attach -> image -> type . "\" />\n"; // Ajout des images jointes
	if ($item -> geocode) {
		list($lat, $lon) = explode(" ", $item -> geocode);
		echo "		<geo:lat>$lat</geo:lat>\n";
		echo "		<geo:long>$lon</geo:long>\n";
	}
	echo "	</item>\n";
}
echo "</channel>\n";
echo "</rss>\n";
?>